<?php

require_once($_SERVER['DOCUMENT_ROOT'] . "/classes/users.php");
require_once($_SERVER['DOCUMENT_ROOT'] . "/guest/models/GuestInviteModel.php");

/**
 * Class Form_Validate_UrlInvited
 * 
 *       
 */
class Form_Validate_UrlInvited extends Zend_Validate_Abstract 
{
    const ERROR_USER_INVITED  = 'invited';
    
    protected $_messageTemplates = array(
        self::ERROR_USER_INVITED => ' %s     .'
    );
    
    //@todo:     Zend_Validation
    // NoUserExists    
    protected $message_type = array(
        GuestConst::TYPE_VACANCY => ' ',
        GuestConst::TYPE_PROJECT => ' '
    );
    
    protected $type;
    protected $_str_type;
    
    /**
     * Sets validator options
     *
     * @param  integer|array|Zend_Config $options
     * @return void
     */
    public function __construct($options)
    {
        if ($options instanceof Zend_Config) {
            $options = $options->toArray();
        } elseif (!is_array($options)) {
            $options = func_get_args();
            $temp['type'] = array_shift($options);
            $options = $temp;
        }
        
        if (array_key_exists('type', $options)) {
            $this->setType($options['type']);
        }

        $this->_str_type = @$this->message_type[$this->type];
        
        $this->_messageTemplates[self::ERROR_USER_INVITED] = sprintf(
                $this->_messageTemplates[self::ERROR_USER_INVITED], 
                $this->_str_type
        );
    }
    
    public function setType($type)
    {
        $this->type = $type;
    }

    public function isValid($value) 
    {
        $isValid = true;
        
        $this->_setValue($value);
        
        $guestInviteModel = new GuestInviteModel();
       
        if ($guestInviteModel->isExistLink($value)) {
            $this->_error(self::ERROR_USER_INVITED);
            $isValid = false;
        }
        
        return $isValid;
    }
}