/*
---
 
script: MooEditable.English.US.js
 
description: MooEditable messages for US English.
 
license: MIT-style license
 
authors:
- Lim Chee Aun
 
requires:
- MooEditable
- more:1.2.4.2/Lang

provides: [MooEditable.English.US]

...
*/

Locale.define('en-US', 'MooEditable', {

    // MooEditable
    ok: 'OK',
    cancel: 'Cancel',
    bold: 'Bold',
    italic: 'Italic',
    underline: 'Underline',
    strikethrough: 'Strikethrough',
    unorderedList: 'Unordered List',
    orderedList: 'Ordered List',
    indent: 'Indent',
    outdent: 'Outdent',
    undo: 'Undo',
    redo: 'Redo',
    removeHyperlink: 'Remove Hyperlink',
    addHyperlink: 'Add Hyperlink',
    selectTextHyperlink: 'Please select the text you wish to hyperlink.',
    enterURL: 'Enter URL',
    enterImageURL: 'Enter image URL',
    addImage: 'Add Image',
    toggleView: 'Toggle View',
    insertcode: 'Insert code',

    // MooEditable.Charmap
    insertCustomCharacter: 'Insert custom character',
    insertCharacter: 'Insert character',

    // MooEditable.Extras
    blockFormatting: 'Block Formatting',
    paragraph: 'Paragraph',
    heading1: 'Heading 1',
    heading2: 'Heading 2',
    heading3: 'Heading 3',
    alignLeft: 'Align Left',
    alignRight: 'Align Right',
    alignCenter: 'Align Center',
    alignJustify: 'Align Justify',
    removeFormatting: 'Remove Formatting',
    insertHorizontalRule: 'Insert Horizontal Rule',

    // MooEditable.Flash
    embed: 'Enter embed code',
    flashEmbed: 'Flash Embed',

    // MooEditable.Forecolor
    changeColor: 'Change Color',

    // MooEditable.Image
    imageAlt: 'alt',
    imageClass: 'class',
    imageAlign: 'align',
    imageAlignNone: 'none',
    imageAlignLeft: 'left',
    imageAlignCenter: 'center',
    imageAlignRight: 'right',
    addEditImage: 'Add/Edit Image',

    // MooEditable.Pagebreak
    pageBreak: 'Page break',

    // MooEditable.Smiley
    insertSmiley: 'Insert Smiley',

    // MooEditable.Table
    tableColumns: 'columns',
    tableRows: 'rows',
    tableWidth: 'width',
    tableClass: 'class',
    tableType: 'type',
    tableHeader: 'Header',
    tableCell: 'Cell',
    tableAlign: 'align',
    tableAlignNone: 'none',
    tableAlignCenter: 'center',
    tableAlignRight: 'right',
    tableValign: 'vertical align',
    tableValignNone: 'none',
    tableValignTop: 'top',
    tableValignMiddle: 'middle',
    tableValignBottom: 'bottom',
    addTable: 'Add Table',
    editTable: 'Edit Table',
    addTableRow: 'Add Table Row',
    editTableRow: 'Edit Table Row',
    mergeTableRow: 'Merge Table Row',
    splitTableRow: 'Split Table Row',
    deleteTableRow: 'Delete Table Row',
    addTableCol: 'Add Table Column',
    editTableCol: 'Edit Table Column',
    mergeTableCell: 'Merge Table Cell',
    splitTableCell: 'Split Table Cell',
    deleteTableCol: 'Delete Table Column',

    // MooEditable.UI.ExtendedLinksDialog
    protocol: 'protocol',
    link: 'link',
    email: 'e-Mail',
    urlWithoutHttp: 'URL (without http://)',
    window: 'window',
    sameWindow: 'same window',
    newWindow: 'new window'

});


Locale.define('ru-RU', 'MooEditable', {
	
    // MooEditable
    ok: 'OK',
    cancel: '',
    bold: '',
    italic: '',
    underline: '',
    strikethrough: '',
    unorderedList: ' ',
    orderedList: ' ',
    indent: ' ',
    outdent: ' ',
    undo: '',
    redo: '',
    removeHyperlink: ' ',
    addHyperlink: ' ',
    selectTextHyperlink: ',  .',
    enterURL: ' ',
    enterImageURL: '  ',
    addImage: ' ',
    toggleView: 'HTML-',
    insertcode: ' ',

    enterVideoURL: '  ',
    addVideo: ' ',
	
    // MooEditable.Charmap
    insertCustomCharacter: 'Insert custom character',
    insertCharacter: 'Insert character',
	
    // MooEditable.Extras
    blockFormatting: '',
    paragraph: '',
    heading1: ' 1',
    heading2: ' 2',
    heading3: ' 3',
    alignLeft: 'Align Left',
    alignRight: 'Align Right',
    alignCenter: 'Align Center',
    alignJustify: 'Align Justify',
    removeFormatting: 'Remove Formatting',
    insertHorizontalRule: 'Insert Horizontal Rule',
	
    // MooEditable.Flash
    embed: 'Enter embed code',
    flashEmbed: 'Flash Embed',
	
    // MooEditable.Forecolor
    changeColor: 'Change Color',
	
    // MooEditable.Image
    imageAlt: 'alt',
    imageClass: 'class',
    imageAlign: 'align',
    imageAlignNone: 'none',
    imageAlignLeft: 'left',
    imageAlignCenter: 'center',
    imageAlignRight: 'right',
    addEditImage: 'Add/Edit Image',
	
    // MooEditable.Pagebreak
    pageBreak: ' ',
	
    // MooEditable.Smiley
    insertSmiley: 'Insert Smiley',
	
    // MooEditable.Table
    tableColumns: 'columns',
    tableRows: 'rows',
    tableWidth: 'width',
    tableClass: 'class',
    tableType: 'type',
    tableHeader: 'Header',
    tableCell: 'Cell',
    tableAlign: 'align',
    tableAlignNone: 'none',
    tableAlignCenter: 'center',
    tableAlignRight: 'right',
    tableValign: 'vertical align',
    tableValignNone: 'none',
    tableValignTop: 'top',
    tableValignMiddle: 'middle',
    tableValignBottom: 'bottom',
    addTable: 'Add Table',
    editTable: 'Edit Table',
    addTableRow: 'Add Table Row',
    editTableRow: 'Edit Table Row',
    mergeTableRow: 'Merge Table Row',
    splitTableRow: 'Split Table Row',
    deleteTableRow: 'Delete Table Row',
    addTableCol: 'Add Table Column',
    editTableCol: 'Edit Table Column',
    mergeTableCell: 'Merge Table Cell',
    splitTableCell: 'Split Table Cell',
    deleteTableCol: 'Delete Table Column',

    codeSelect: ''
	
});

Locale.use('ru-RU');